class UNet3D(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  _resize_output : bool
  encoder : __torch__.Encoder
  decoder : __torch__.Decoder
  head : __torch__.torch.nn.modules.conv.___torch_mangle_16.Conv3d
  def forward(self: __torch__.UNet3D,
    x: Tensor) -> Tensor:
    _0 = __torch__.torch.nn.functional.___torch_mangle_17.interpolate
    shape = torch.slice(torch.size(x), 2)
    encoder_feats = (self.encoder).forward(x, )
    _1 = self.decoder
    _2 = encoder_feats[-1]
    _3 = torch.slice(encoder_feats, None, -1)
    out = (_1).forward(_2, torch.slice(_3, None, None, -1), )
    out0 = (self.head).forward(out, )
    if self._resize_output:
      out2 = _0(out0, shape, None, "trilinear", False, None, )
      out1 = out2
    else:
      out1 = out0
    return out1
class Encoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  blocks : __torch__.torch.nn.modules.container.ModuleList
  pool_layer : __torch__.torch.nn.modules.pooling.MaxPool3d
  def forward(self: __torch__.Encoder,
    x: Tensor) -> List[Tensor]:
    feats = annotate(List[Tensor], [])
    _4 = self.blocks
    _5 = getattr(_4, "0")
    _6 = getattr(_4, "1")
    _7 = getattr(_4, "2")
    _8 = getattr(_4, "3")
    x0 = (_5).forward(x, )
    _9 = torch.append(feats, x0)
    x1 = (self.pool_layer).forward(x0, )
    x2 = (_6).forward(x1, )
    _10 = torch.append(feats, x2)
    x3 = (self.pool_layer).forward(x2, )
    x4 = (_7).forward(x3, )
    _11 = torch.append(feats, x4)
    x5 = (self.pool_layer).forward(x4, )
    x6 = (_8).forward(x5, )
    _12 = torch.append(feats, x6)
    x7 = (self.pool_layer).forward(x6, )
    return feats
class Block(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.torch.nn.modules.conv.Conv3d
  conv2 : __torch__.torch.nn.modules.conv.___torch_mangle_0.Conv3d
  def forward(self: __torch__.Block,
    x: Tensor) -> Tensor:
    x8 = __torch__.torch.nn.functional.relu((self.conv1).forward(x, ), True, )
    x9 = __torch__.torch.nn.functional.relu((self.conv2).forward(x8, ), True, )
    return x9
class Decoder(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  first_block : __torch__.torch.nn.modules.conv.___torch_mangle_10.Conv3d
  blocks : __torch__.torch.nn.modules.container.___torch_mangle_15.ModuleList
  interp_layer : __torch__.torch.nn.modules.upsampling.Upsample
  def forward(self: __torch__.Decoder,
    x: Tensor,
    encoder_features: List[Tensor]) -> Tensor:
    x10 = (self.first_block).forward(x, )
    _13 = torch.ge(torch.len(encoder_features), 1)
    if _13:
      x12 = (self.interp_layer).forward(x10, )
      feats = __torch__.center_crop(encoder_features[0], torch.size(x12), )
      x13 = torch.cat([x12, feats], 1)
      x14 = (getattr(self.blocks, "0")).forward(x13, )
      x11 = x14
    else:
      x11 = x10
    _14 = torch.ge(torch.len(encoder_features), 2)
    if _14:
      x16 = (self.interp_layer).forward(x11, )
      feats0 = __torch__.center_crop(encoder_features[1], torch.size(x16), )
      x17 = torch.cat([x16, feats0], 1)
      x18 = (getattr(self.blocks, "1")).forward(x17, )
      x15 = x18
    else:
      x15 = x11
    return x15
def center_crop(x: Tensor,
    shape: List[int]) -> Tensor:
  d = torch.sub(torch.tensor(torch.size(x)), torch.tensor(shape))
  d2 = torch.floor_divide(d, 2)
  _15 = torch.slice(torch.slice(x), 1)
  _16 = torch.sub(torch.select(d, 0, 2), torch.select(d2, 0, 2))
  _17 = (torch.size(x))[2]
  _18 = torch.add(torch.neg(torch.select(d2, 0, 2)), _17)
  _19 = torch.slice(_15, 2, annotate(int, _16), annotate(int, _18))
  _20 = torch.sub(torch.select(d, 0, 3), torch.select(d2, 0, 3))
  _21 = (torch.size(x))[3]
  _22 = torch.add(torch.neg(torch.select(d2, 0, 3)), _21)
  _23 = torch.slice(_19, 3, annotate(int, _20), annotate(int, _22))
  _24 = torch.sub(torch.select(d, 0, 4), torch.select(d2, 0, 4))
  _25 = (torch.size(x))[4]
  _26 = torch.add(torch.neg(torch.select(d2, 0, 4)), _25)
  _27 = torch.slice(_23, 4, annotate(int, _24), annotate(int, _26))
  return _27
